#!/bin/bash
#
# $Header: /CVSROOT/public/scylla-charybdis/md5backup/bin/sc-move.sh,v 1.4 2004/06/19 12:31:29 tino Exp $
#
# $Log: sc-move.sh,v $
# Revision 1.4  2004/06/19 12:31:29  tino
# minor improvements
#
# Revision 1.3  2004/06/18 23:51:16  tino
# see ChangeLog
#
# Revision 1.2  2004/05/15 14:44:54  tino
# updated
#
# Revision 1.1  2004/05/04 05:11:01  tino
# sc-backup.sh: backup via scylla+charybis; dobackup.sh convenience script

MOVETARG="127.0.0.1"
MOVEPORT="999"
MOVEPASS="Tunneled"
MOVESRC="${1:-md5move}"
MOVESPEED=

[ -s sc-move.conf ] && . sc-move.conf
[ -s "sc-move.$1.conf" ] && . "sc-move.$1.conf"

if [ ! -d "$MOVESRC" ]
then
	echo "wrong arg: $MOVESRC"
	exit 1
fi
if [ ! -d "tmp" ]
then
	echo "missing tmp directory"
	exit 1
fi

TMP="tmp/$$.in"
trap 'rm -f "$TMP"' 0

buildlist()
{
splitarg=""
splittest=aa
if split -a6 </dev/null 2>/dev/null
then
	splitarg=-a6
	splittest=aaaaaa
fi
n="`expr 100 + ${RANDOM:1:3}`"
echo "building file list: $n"
find "$MOVESRC"/*/. -type f -print |
split $splitarg -l$n - "tmp/run."
rm -f "tmp/again"
[ -s tmp/run.$splittest ]
}

out()
{
  echo -n "
[60C$*
"
}

movefiles()
{
done=false
for a in tmp/run.*
do
	[ ! -f "$a" ] && continue
	mv -f "$a" "$TMP" || continue
	out "do $a"
	if bin/charybdis "$MOVETARG" "$MOVEPORT" "$MOVEPASS" - $MOVESPEED < "$TMP"
	then
		out "ok $a"; echo
#		cat "$TMP" >> "tmp/ok"
		while read del
		do
			rm -f "$del"
		done < "$TMP"
		sed -n 's/\/[^.][^/]*$//p' "$TMP" |
		sort -u |
		while read dir
		do
			rmdir "$dir" 2>/dev/null
		done
		sed -n 's/\/[^.][^/]*\/[^.][^/]*$//p' "$TMP" |
		sort -u |
		while read dir
		do
			rmdir "$dir" 2>/dev/null
		done
	else
		out "up $a"; echo
		cat "$TMP" >> "tmp/again"
	fi
	rm -f "$TMP"
	done=:
done
$done
}

movefiles && exit 1
buildlist
